/*  Copyright Garrett Kajmowicz, 2005.  Licenced under the GNU GPL.
 *  This file defines a set of functions which will load the modules for 
 *  object definitions and code.
 *
 *
 */


#ifndef AnalysisLoader_H
#define AnalysisLoader_H


#include <string>
#include <map>

#include <carrot/Analysis.h>
#include <carrot/AnalysisFunctions.h>
#include <carrot/nocase_cmp.h>


//The following function takes a path location and returns all
//of the information required to use the modules

typedef std::map<std::string, AnalysisFunctions, nocase_cmp> AnalysisMap;

AnalysisMap openAnalysis(const std::string path = ".", bool printflag = false, 
			      AnalysisMap retval = AnalysisMap());

void closeAnalysis(AnalysisMap & m);


#endif
