// This may look like C code, but it is really -*- C++ -*-
//
// Test OPA analysis. For now do something simple to just to test the
// concept.
//
// 
// by Carlos E. Christoffersen

#ifndef OPA_H
#define OPA_H

#include <carrot/Analysis.h>
#include <string>

class Circuit;

class OPA : public Analysis
{
public:

  // ParmSet takes care of parameter handling
  OPA(ParmSet* pset1) : Analysis(pset1) {}

  virtual ~OPA() {}

  // The main method to actually run the analysis
  // (Decide what to do with the results)
  virtual void run(Circuit* cir, OutputManager* om);

private:
  
  void getSens(ParmSet* ps, Terminal *term, 
	       const int& nrcs, const int& max_parms, const int& max_CS, 
	       const double* uvec, double *vj,
	       const double *d, const double *uvec_a, double *rhs_deriv,
	       double *Jac, double *sens);

};

#endif
