#include <carrot/Terminal.h>
#include <carrot/ElementNode.h>

// 6 seems to be a reasonable start value
Terminal::Terminal(const std::string& name, bool intern) 
  : CircuitItem(), NamedItem(name), myRC(-1), elemVec(), internal(intern)
{
  elemVec.reserve(6);
}

Terminal::~Terminal()
{
  // Circuit takes care of inconsistencies (tells elements if
  // necessary)
}

void Terminal::unlink(ElementNode* en)
{
  // First make sure element is connected
  for (std::vector<ElementNode*>::iterator celem = elemVec.begin();
       celem != elemVec.end(); celem++)
    if ((*celem) == en) {
      en->unlink(this);
      // Remove element from vector
      // For speed, swap element to be removed with last element
      // and remove last.
      (*celem) = *(elemVec.end()-1);
      elemVec.pop_back();
      return;
    }
  // Control should never reach here.
  assert(false);
}

