// This may look like C code, but it is really -*- C++ -*-
//
// Implements the per-section-length capacitor in a TL
//
// 

#ifndef CapType_H
#define CapType_H 1

class Cap_eval {
public:

  Cap_eval(int *iparm) 
  {
    this->iparm = iparm;
  } 

  // Main evaluation function. Only voltage dependence considered here.
  template <typename myDouble>
  inline void operator()(myDouble& c, myDouble* dparm)
  {
    myDouble deltax = dparm[LENGTH] / double(iparm[NSECT]);
    c = sqrt(dparm[K]) / dparm[Z0MAG] / c0 * deltax;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  int *iparm; 

};

typedef FADBADLinearVCS<Cap_eval, LinearVCQS, MAX_DPARM_INDEX> CapType;

#endif
