// This may look like C code, but it is really -*- C++ -*-
//
// Implements the per-section-length conductor in a TL
//
// 

#ifndef GType_H
#define GType_H 1

class G_eval {
public:

  G_eval(int *iparm) 
  {
    this->iparm = iparm;
  } 

  // Main evaluation function. 
  template <typename myDouble>
  inline void operator()(myDouble& g, myDouble* dparm)
  {
    myDouble c = sqrt(dparm[K]) / dparm[Z0MAG] / c0;
    myDouble deltax = dparm[LENGTH] / double(iparm[NSECT]);
    if (dparm[FOPT] != 0. && dparm[TAND] != 0.)
      g = dparm[TAND] * twopi * dparm[FOPT] * c * deltax;
    else
      g = 1e-10;
  }

  //private:
  
  // Pointer to integer parameter vector from macroelement
  int *iparm; 

};

typedef FADBADLinearVCS<G_eval, LinearVCCS, MAX_DPARM_INDEX> GType;

#endif
