// This may look like C code, but it is really -*- C++ -*-
//
// Parent class for all analysis types
//
// 

#ifndef Analysis_H
#define Analysis_H

#include <carrot/ParmSet.h>
#include <carrot/OutputManager.h>

class Circuit;

class Analysis
{
public:

  // ParmSet takes care of parameter handling
  Analysis(ParmSet* pset1) : pset(pset1) {}

  virtual ~Analysis() {}

  // This is to make sure we can access parameters from any
  // macroelelement.
  inline ParmSet* getParmSet()
  {
    return pset;
  }

  // The main method to actually run the analysis
  // (Decide what to do with the results)
  virtual void run(Circuit* cir, OutputManager* om) = 0;

private:

  // Parameter set (Spice `.model') pointer
  ParmSet* pset;

};

#endif
