/*  Copyright Garrett Kajmowicz, 2004.  Licenced under the GNU GPL.
 *  This file defines a set of functions which will load the modules for 
 *  object definitions and code.
 *
 *
 */


#ifndef AnalysisFunctions_H
#define AnalysisFunctions_H

#include <carrot/ParmSet.h>
#include <carrot/Analysis.h>

//The struct ModuleOpts will contain pointers to all of the
//Required functions in terms of running the software

struct AnalysisFunctions
{
  //The following pointer is used to keep track of the open
  // file handle for the library manipulation routines
  void * handle;

  //Need to be able to get the name of the module which we are using
  const char * (*AnalysisName)();

  //These two functions create and delete Parameter Sets
  ParmSet * (*newParmSet)(const char * model);
  void (*delParmSet)(ParmSet * );

  //These two functions create and delete
  Analysis * (*newObject)(ParmSet * p);
  void (*delObject)(Analysis * e);

};


#endif
