// This may look like C code, but it is really -*- C++ -*-
//
// This is a base class for any circuit item. It handles the index in
// the circuit vectors. It may be used to enumerate nodes too.  Later
// it may be expanded to handle names, but for now it is not
// necessary.
//
// by Carlos E. Christoffersen

#ifndef CircuitItem_h
#define CircuitItem_h 1

#include <cassert>

class CircuitItem 
{
public:

  inline const int& getIndex() const
  {
    return index;
  }

  inline void setIndex(const int& idx)
  {
    // index can be set only if not set or if it is been reset.
    // Disabled:    assert((index == -1) || (idx == -1));
    index = idx;
  }
  
protected:
  
  CircuitItem() : index(-1) {}
  
  virtual ~CircuitItem() {}
  
private:
  
  int index;

};


#endif


