// This may look like C code, but it is really -*- C++ -*-
//
// Base class to hold one simulation sample result (nodal voltages,
// phasors,etc.)
//
// by Carlos E. Christoffersen

#ifndef SampleHolder_h
#define SampleHolder_h 1

#include <vector>
#include <string>
#include <cassert>

class SampleHolder 
{
public:

  SampleHolder() {}
  
  virtual ~SampleHolder() {}

  // Write node(index) information to out string
  virtual void writeNode(const int& index, std::string& out) = 0;

  inline void setVal(const double& val)
  {
    value = val;
  }

  inline const double& getVal() const
  {
    return value;
  }

private:

  // Value of `sweep' or time variable
  double value;

};


#endif


